package middleware

import (
	"context"
	"net/http"
	"runtime/debug"

	"gitlab.bit9.local/psc/ems/hinting/internal/logger"
	"go.uber.org/zap"
)

func (mwf RouteMiddlewareFactory) GetRecoveryMiddleware(next http.HandlerFunc) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		defer func() {
			if err := recover(); err != nil {
				l := logger.RequestLoggerFromContext(r.Context())
				*r = *r.Clone(context.WithValue(r.Context(), Error, true))
				l.Error("Recoverying from error", zap.Any("error", err), zap.String("stacktrace", string(debug.Stack())))
			}
		}()
		next.ServeHTTP(w, r)
	}
}
