// Copyright (c) 2022-2023 VMware Carbon Black, all rights reserved

package config

import (
	"os"
	"testing"
)

func Test_Config_ConnectionString(t *testing.T) {
	testData := map[string]string{
		"PGHOST":     "HOST",
		"PGUSER":     "USER",
		"PGPORT":     "1337",
		"PGPASSWORD": "PASS",
		"PGDATABASE": "DATABASENAMEGOESHERE",
	}

	for name, value := range testData {
		err := os.Setenv(name, value)
		if err != nil {
			t.Fatalf("Failed to set environment variable '%s' to '%s': %v", name, value, err)
		}
	}

	cfg := GetInstance()
	if cfg == nil {
		t.Fatalf("Failed to load config from envars")
	}

	if cfg.PostgresqlConfig.DbHost == "" {
		t.Fatalf("Db host did not load")
	}
}
